#include <GL/glut.h>
#include <stdlib.h>

#include "GameObj.h"
#include "Bullet.h"
#include "Ship.h"
#include "TriShip.h"
#include "Ship3D.h"
#include "Ast.h"
#include "AstFract.h"
#include "Ast3DFract.h"
#include "GameSession.h"

#ifdef _WIN32
#define drand48() (((float) rand())/((float) RAND_MAX))
#define srand48(x) (srand((x)))
#endif

/** The main drawing function.
It draw the current ship, all the active bullets,
asteroids and  generic objects
*/
void GameSession::Draw()
{
	S->Draw();
	list<GameObj *>::iterator li;
	for(li=ActiveObj.begin();li!=ActiveObj.end();++li)
		(*li)->Draw();
	list<Bullet *>::iterator lib;
	for(lib=ActiveBullet.begin();lib!=ActiveBullet.end();++lib)
		(*lib)->Draw();
	list<Ast *>::iterator lia;
	for(lia=ActiveAst.begin();lia!=ActiveAst.end();++lia)
		(*lia)->Draw();
}

void GameSession::Update(int dt)
{
	S->Update(dt);
	Clip(S->p);
	list<Bullet *>::iterator lib;
	for(lib=ActiveBullet.begin();lib!=ActiveBullet.end();++lib)
		{
		 (*lib)->Update(dt);
			Clip((*lib)->p);
		 if((*lib)->active==false)
		 {
			 GameObj *todel=*lib;
			 lib=ActiveBullet.erase(lib);
			 S->TerminateBullet();
			 delete todel;
		 }
		 if(lib==ActiveBullet.end()) break;
		}
	list<GameObj *>::iterator li;
	for(li=ActiveObj.begin();li!=ActiveObj.end();++li)
		{
		 (*li)->Update(dt);
			Clip((*li)->p);
		 if((*li)->active==false)
		 {
			 GameObj *todel=*li;
			 li=ActiveObj.erase(li);
			 delete todel;
		 }
		 if(li==ActiveObj.end()) break;
		}

	list<Ast *>::iterator lia;
	for(lia=ActiveAst.begin();lia!=ActiveAst.end();++lia)
		{
		 (*lia)->Update(dt);
			Clip((*lia)->p);
		 if((*lia)->active==false)
		 {
			 GameObj *todel=*lia;
			 lia=ActiveAst.erase(lia);
			 delete todel;
		 }
		 if(lia==ActiveAst.end()) break;
		}
}

void GameSession::Shoot()
{
 S->Shoot(ActiveBullet);
}

void GameSession::Start()
{
	S=new Ship3D("newastro.rawc");
	Ast *a;
	for(int i=0;i<10;i++)
		{
			a=new Ast3DFract();
			a->p.x()=drand48()*SpaceSize*2 - SpaceSize;	
			a->p.y()=drand48()*SpaceSize*2 - SpaceSize;
			a->v.x()=drand48()*40 - 20;	
			a->v.y()=drand48()*40 - 20;
			a->av=drand48()*70;
			a->axis=Normalize(Point3f(drand48(),drand48(),drand48()));
			a->size=5*(1+rand()%4);
		 ActiveAst.push_back(a);
		}
}
